# Maintainers

## About This File

You can find out who's contributed recently just by looking at GitHub's
[contributors list](../../graphs/contributors). But there are a few more
things you ought to know about who maintains this code, and how they do it:

1. Make sure you read our [contributor guidelines](http://bit.ly/2ugd0bq)
   so you understand how we work and how to collaborate effectively.
   This includes instructions about pull request and code review protocols,
   and it explains what we mean by calling someone a "maintainer" in this
   file.
2. Be aware that individual folders in the project may have more
   specific maintainers; if you see another `MAINTAINERS.md` in a subfolder,
   that governs the tree below it.
3. A lot of interactions with maintainers take place on [Jira](https://jira.hyperledger.org/projects/IS).
   You'll need [Linux Foundation credentials](https://identity.linuxfoundation.org) to
   comment there; creating them is self-service. The project name you want, once in
   jira, is "IS".
4. The other important communication mechanism to know about is [Rocket.Chat](https://chat.hyperledger.org).
   Again, you use your Linux Foundation credentials. Most of the team hangs out
   there during their work day; look for `#indy-sdk`, `#indy`, `#indy-pr-review`,
   and so forth.
5. We use developer certificate of origin (DCO) in all hyperledger repositories,
  so to get your pull requests accepted, you must certify your commits by signing off on each commit.
  More information can be found in [Signing Commits](docs/signing-commits.md) article.

## Who To Contact

For ordinary questions, we suggest you contact [active contributors](../../graphs/contributors)
generically, on rocket.chat `#indy-sdk`. If that doesn't get someone's attention,
feel free to contact the contributors individually.

Maintainers are busy and delegate many decisions to other trusted
contributors. However, it is appropriate to contact them if you have a
complex design decision or a controversial PR.

## Maintainers

* Sergej - maintainer. geo=Voronezh, Russia; github=jovfer, rocket.chat=sergey.minaev, jira=sergey.minaev

## Emeritus Maintainers

* Slava - maintainer and scrum team lead. geo=Voronezh, Russia; github=vimmerru, rocket.chat=gudkov, jira=gudkov
* Doug - vcx maintainer. geo=Utah, USA; github=glowkey; rocket.chat, jira=DouglasWightman
