
# Namespaces
The Indy SDK wrapper for .NET is separated into a series of namespaces that contain types for performing specific
types of interactions.  The list of these namespaces and their function can be found below and the you can access the types
can be accessed by selecting the namespace from the sidebar.

## Hyperledger.Indy
General types that relate to the .NET wrapper as a whole.  This includes exception types that are common to all interactions.  

See the <xref:Hyperledger.Indy> Namespace topic for details. 

## Hyperledger.Indy.AnonCredsApi
Types for generating and managing anonymous credentials including claims, claim schema, proofs, etc.

See the <xref:Hyperledger.Indy.AnonCredsApi> Namespace topic for details. 

## Hyperledger.Indy.BlobStorageApi
Types for reading and writing Binary Large OBjects to and from storage.

See the <xref:Hyperledger.Indy.BlobStorageApi> Namespace topic for details. 

## Hyperledger.Indy.CryptoApi
Types for performing common pure cryptographic functions that are not specific to the <xref:Hyperledger.Indy.DidApi.Did> functionality such as generating 
key-pairs, signing, verifying and anonymous encryption.

See the <xref:Hyperledger.Indy.CryptoApi> Namespace topic for details. 

## Hyperledger.Indy.DidApi
Types for creating and managing DIDs, key management, encryption, decryption, digital signatures, etc.

See the <xref:Hyperledger.Indy.DidApi> Namespace topic for details. 

## Hyperledger.Indy.LedgerApi
Types for generating transaction messages as well as signing and sending them to a ledger pool.

See the <xref:Hyperledger.Indy.LedgerApi> Namespace topic for details. 

## Hyperledger.Indy.PairwiseApi
Types for managing pairwise relationships between DIDs.

See the <xref:Hyperledger.Indy.PairwiseApi> Namespace topic for details. 

## Hyperledger.Indy.PoolApi
Types for managing connections to node pools that host ledgers.

See the <xref:Hyperledger.Indy.PoolApi> Namespace topic for details. 

## Hyperledger.Indy.WalletApi
Types for managing wallets which can contain DIDs, their associated keys and other key/value data.

See the <xref:Hyperledger.Indy.WalletApi> Namespace topic for details. 